<?php

//
// HORIZONT Software GmbH, Munich
//

    define('BS_PLANNER_ROLE', 'PLANNER');
    define('BS_PLANNER_PARAM', 'PLANNER');



    require_once('wai_functions.php');
    require_once('hwm_lib.php');



    function bs_get_process_param($process, $param)
    {
        if (!hwm_db_lock(array('client' => false, 'param' => false)))
            return false;
        $value = hwm_get_process_param($process, $param);
        if ($value === false)
        {
            hwm_db_rollback();
            return false;
        }
        if (!hwm_db_commit())
            return false;
        return $value;
    }



    function bs_set_process_param($process, $param, $val)
    {
        if (!hwm_db_lock(array('client' => false, 'param' => true)))
            return false;
        if (!hwm_set_process_param($process, $param, $val))
        {
            hwm_db_rollback();
            return false;
        }
        if (!hwm_db_commit())
            return false;
        return true;
    }



    /**
     * Set the first user with the role BS_PLANNER_ROLE working on the process,
     * into the parameter BS_PLANNER_PARAM.
     */
    function bs_set_first_planner()
    {
        $role = hwm_get_role();
        if ($role === false)
            return false;
        if ($role !== BS_PLANNER_ROLE)
            return true; // ignore for activity of a none PLANNER role
        $process = hwm_get_process();
        if ($process === false)
            return false;
        $value = bs_get_process_param($process, BS_PLANNER_PARAM);
        if ($value === false)
            return false;
        $value = trim($value);
        if ($value !== '')
            return true; // parameter already set
        $value = hwm_get_user();
        if ($value === false)
            return false;
        if (!bs_set_process_param($process, BS_PLANNER_PARAM, $value))
            return false;
        return true;
    }



    function bs_pre_action()
    {
        if (!bs_set_first_planner())
            return false;
        return true;
    }
?>
